#include <stdio.h>
#include <ctype.h>

/*
EXEC SQL include sqltypes;
EXEC SQL include locator;
EXEC SQL include datetime;
EXEC SQL include decimal;
*/

#define SQLBUFFSZ 256

/*
EXEC SQL BEGIN DECLARE SECTION;
    loc_t lcat_descr;
    loc_t lcat_picture; 
EXEC SQL END DECLARE SECTION; 
*/

int ix_err(); /* Error function */

long getrow(char *sysdesc);

int main(){
   long ret;
   short data_found = 0;

   EXEC SQL BEGIN DECLARE SECTION;
        char sql[SQLBUFFSZ], db_name[30];
        char name[40];
        int sel_cnt, i;
        short type;
   EXEC SQL END DECLARE SECTION;

   EXEC SQL whenever sqlerror call ix_err;

   strcpy(db_name, "addr");
   EXEC SQL connect to :db_name;

   strcpy(sql, "select * from abc");
   EXEC SQL prepare sel_id from :sql;

   EXEC SQL declare sel_curs cursor for sel_id;  
   EXEC SQL allocate descriptor 'selcat';
   EXEC SQL describe sel_id using sql descriptor 'selcat';

   if(SQLCODE != 0){
      printf("** Statement is not a SELECT.\n");
      free_stuff();
      EXEC SQL disconnect current;
      exit(0);
   }

   /* Determine the number of columns in the select list */

   EXEC SQL get descriptor 'selcat' :sel_cnt = COUNT;
   printf("There are %d columns\n", sel_cnt);

   EXEC SQL open sel_curs;

   /* fetch a rows */ 
   while(ret = getrow("selcat")){
      data_found = 1;
      if(ret < 0){
         EXEC SQL disconnect current;
 	 exit(0);
      }
      disp_data(sel_cnt, "selcat"); /* display the data */
   }
   printf("** EOF **\n");
   free_stuff();
   return 0;
}

long getrow(sysdesc)
EXEC SQL BEGIN DECLARE SECTION;
    PARAMETER char *sysdesc;
EXEC SQL END DECLARE SECTION;
{
    EXEC SQL fetch sel_curs using sql descriptor :sysdesc;

    return ( strncmp(SQLSTATE, "02", 2) != 0 );
}

#define MAX_FIELD_LEN 4096

disp_data(col_cnt, sysdesc)
int col_cnt;
EXEC SQL BEGIN DECLARE SECTION;
    PARAMETER char * sysdesc;
EXEC SQL END DECLARE SECTION;
{
    EXEC SQL BEGIN DECLARE SECTION;
        int   i;
        short ind;
        char  name[40];
        char  data[MAX_FIELD_LEN];
        char  data1[MAX_FIELD_LEN];
	int   type;
       	int   len;
    EXEC SQL END DECLARE SECTION;
    unsigned int x;
col_cnt=5;
    for(i = 1; i <= col_cnt; i++)
	{
        EXEC SQL get descriptor :sysdesc VALUE	1
						:name = NAME,
						:type = TYPE,
						:len = LENGTH,
						:ind = INDICATOR,
						:data = DATA;
        strncpy(data1, data, MAX_FIELD_LEN);

        for(x=MAX_FIELD_LEN - 1 - 1; x > 0; x--){
           //printf("---->%d %d\n", x, data1[x]);

           if (data1[x]==' ')
              data1[x]='\0';
           else
              break;
        }

        printf(">%2i | %-10s | %3d | %3d | %3d | %s<\n", i, name, type, len, ind, (ind == -1) ? NULL : data1);

        }
} 

free_stuff()
{

    EXEC SQL free sel_id;	/* free resources for statement */
    EXEC SQL free sel_curs;	/* free resources for cursor */

    /* free system descriptor area */
    EXEC SQL deallocate descriptor 'selcat'; 
}

ix_err()
{
    printf("Informix Error %s\n", SQLSTATE);
    exit(1);
}
