#include <sqlhdr.h>
#include <sqlca.h>

#if !defined(__STDC__)
#define const 
#endif

#line 1 "ix_dbc.esql.ec"
#include "../mad/mad.h"
#include "../mad/prop.h"

#define DBC_DATABASE		"DATABASE"

#define SQL_BUFF_SIZE       1024 * 10
#define FIELD_BUFF_SIZE     1024 * 10
#define DB_BUFF_SIZE        30
#define FIELDNAME_BUFF_SIZE 40

#define SQLSTATE_ERR        "02"
//#define SQLSTATE_ERR_LEN strlen(SQLSTATE_ERROR)
#define SQLSTATE_ERR_LEN    2

#define chkerr() ( strncmp(SQLSTATE, SQLSTATE_ERR, SQLSTATE_ERR_LEN) < 0 )

//Uncomment this for extended Informix messages,
//direct from Informix server to LOG_NOTIFY_DEBUG
#define INFORMIX_DEBUG

#ifndef INFORMIX_DEBUG

#define ix_err()

#else

int ix_err(){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 28 "ix_dbc.esql.ec"

#line 29 "ix_dbc.esql.ec"
char msg[FIELD_BUFF_SIZE];
int len;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 31 "ix_dbc.esql.ec"


/*
 *    EXEC SQL get diagnostics exception 1
 *                           :msg = MESSAGE_TEXT,
 *                           :len = MESSAGE_LENGTH;
 */
#line 33 "ix_dbc.esql.ec"
  {
#line 33 "ix_dbc.esql.ec"
  static struct hostvar_struct _SQhtab[] =
    {
      { 0, 6, 100, sizeof(msg), 0 },
      { 0, 7, 102, sizeof(len), 0 },
      { 0, 0, 0, 0, 0 }
#line 35 "ix_dbc.esql.ec"
    };
  _SQhtab[0].hostaddr = (msg);
  _SQhtab[1].hostaddr = (char *)&len;
#line 35 "ix_dbc.esql.ec"
  _iqgetdiag(_SQhtab, 1);
#line 35 "ix_dbc.esql.ec"
  }

   msg[len] = '\0';
   printflog(LOG_NOTIFY_DEBUG, "Informix Error (%s) %s\n", SQLSTATE, msg);

   //exit(1);
   return 0;
}

#endif

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

boolean IxDBConnection::connect(Properties *cfg){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 51 "ix_dbc.esql.ec"

#line 52 "ix_dbc.esql.ec"
char db_name[DB_BUFF_SIZE];
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 53 "ix_dbc.esql.ec"


   //Init error function
   //The #defines will NOT help there :(((, but can help in function itself
/*
 *    EXEC SQL whenever sqlerror call ix_err;
 */
#line 57 "ix_dbc.esql.ec"


   //Connect to the db
   strncpy(db_name, cfg->get(DBC_DATABASE, ""), DB_BUFF_SIZE );
/*
 *    EXEC SQL connect to :db_name;
 */
#line 61 "ix_dbc.esql.ec"
  {
#line 61 "ix_dbc.esql.ec"
  _iqconnect(0, db_name, (char *) 0, (char *) 0, (char *) 0, 0);
#line 61 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 61 "ix_dbc.esql.ec"
    ix_err();
#line 61 "ix_dbc.esql.ec"
  }

   return chkerr();
};

void IxDBConnection::disconnect(){
/*
 *    EXEC SQL disconnect current;
 */
#line 67 "ix_dbc.esql.ec"
  {
#line 67 "ix_dbc.esql.ec"
  _iqdisconnect(3, (char *) 0, 0, 0);
#line 67 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 67 "ix_dbc.esql.ec"
    ix_err();
#line 67 "ix_dbc.esql.ec"
  }
};

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

void IxDBC::setSQL(const char *sql){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 75 "ix_dbc.esql.ec"

#line 76 "ix_dbc.esql.ec"
char sql1[SQL_BUFF_SIZE];
char *syssel;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 78 "ix_dbc.esql.ec"

   syssel = IX_SEL;

   //Set SQL
   strncpy(sql1, sql, SQL_BUFF_SIZE);
/*
 *    EXEC SQL prepare :syssel from :sql1;
 */
#line 83 "ix_dbc.esql.ec"
  {
#line 83 "ix_dbc.esql.ec"
#line 83 "ix_dbc.esql.ec"
  _iqnprep((char *) syssel, sql1);
#line 83 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 83 "ix_dbc.esql.ec"
    ix_err();
#line 83 "ix_dbc.esql.ec"
  }

   sqlstate = chkerr();
};

boolean IxDBC::exec(){
   if (!sqlstate)
      return false;

/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 92 "ix_dbc.esql.ec"

#line 93 "ix_dbc.esql.ec"
char *sysdesc;
char *syssel;
char *syscurs;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 96 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;
   syssel  = IX_SEL;
   syscurs = IX_CURS;

/*
 *    EXEC SQL declare :syscurs cursor for :syssel;
 */
#line 101 "ix_dbc.esql.ec"
  {
#line 101 "ix_dbc.esql.ec"
#line 101 "ix_dbc.esql.ec"
  _iqcddcl(_iqlocate_cursor((char *) syscurs, 0), (char *) syscurs, _iqlocate_cursor((char *) syssel, 1), 0);
#line 101 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 101 "ix_dbc.esql.ec"
    ix_err();
#line 101 "ix_dbc.esql.ec"
  }
/*
 *    EXEC SQL allocate descriptor :sysdesc;
 */
#line 102 "ix_dbc.esql.ec"
  {
#line 102 "ix_dbc.esql.ec"
  _iqalloc(sysdesc, 100);
#line 102 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 102 "ix_dbc.esql.ec"
    ix_err();
#line 102 "ix_dbc.esql.ec"
  }
/*
 *    EXEC SQL describe :syssel using sql descriptor :sysdesc;
 */
#line 103 "ix_dbc.esql.ec"
  {
#line 103 "ix_dbc.esql.ec"
#line 103 "ix_dbc.esql.ec"
  _iqdescribe(_iqlocate_cursor((char *) syssel, 101), (struct sqlda **) 0, sysdesc);
#line 103 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 103 "ix_dbc.esql.ec"
    ix_err();
#line 103 "ix_dbc.esql.ec"
  }

   return chkerr();
};

boolean IxDBC::open(){
   if (!exec())
      return false;

/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 112 "ix_dbc.esql.ec"

#line 113 "ix_dbc.esql.ec"
char *syscurs;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 114 "ix_dbc.esql.ec"

   syscurs = IX_CURS;

/*
 *    EXEC SQL open :syscurs;
 */
#line 117 "ix_dbc.esql.ec"
  {
#line 117 "ix_dbc.esql.ec"
#line 117 "ix_dbc.esql.ec"
  _iqdcopen(_iqlocate_cursor((char *) syscurs, 100), (struct sqlda *) 0, (char *) 0, (struct value *) 0, 0, 0);
#line 117 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 117 "ix_dbc.esql.ec"
    ix_err();
#line 117 "ix_dbc.esql.ec"
  }

   _eof=false;

   next();

   return chkerr();
};

void IxDBC::close(){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 127 "ix_dbc.esql.ec"

#line 128 "ix_dbc.esql.ec"
char *sysdesc;
char *syssel;
char *syscurs;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 131 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;
   syssel  = IX_SEL;
   syscurs = IX_CURS;

/*
 *     EXEC SQL free :syssel;                   ** free resources for statement **
 */
#line 136 "ix_dbc.esql.ec"
  {
#line 136 "ix_dbc.esql.ec"
#line 136 "ix_dbc.esql.ec"
  _iqfree(_iqlocate_cursor((char *) syssel, 102));
#line 136 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 136 "ix_dbc.esql.ec"
    ix_err();
#line 136 "ix_dbc.esql.ec"
  }
/*
 *     EXEC SQL free :syscurs;                  ** free resources for cursor **
 */
#line 137 "ix_dbc.esql.ec"
  {
#line 137 "ix_dbc.esql.ec"
#line 137 "ix_dbc.esql.ec"
  _iqfree(_iqlocate_cursor((char *) syscurs, 102));
#line 137 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 137 "ix_dbc.esql.ec"
    ix_err();
#line 137 "ix_dbc.esql.ec"
  }
/*
 *     EXEC SQL deallocate descriptor :sysdesc; ** free system descriptor area **
 */
#line 138 "ix_dbc.esql.ec"
  {
#line 138 "ix_dbc.esql.ec"
  _iqdealloc(sysdesc);
#line 138 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 138 "ix_dbc.esql.ec"
    ix_err();
#line 138 "ix_dbc.esql.ec"
  }
};

void IxDBC::next(){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 142 "ix_dbc.esql.ec"

#line 143 "ix_dbc.esql.ec"
char *sysdesc;
char *syscurs;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 145 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;
   syscurs = IX_CURS;

/*
 *    EXEC SQL fetch :syscurs using sql descriptor :sysdesc;
 */
#line 149 "ix_dbc.esql.ec"
  {
#line 149 "ix_dbc.esql.ec"
  static _FetchSpec _FS0 = { 0, 1, 0 };
#line 149 "ix_dbc.esql.ec"
  _iqcftch(_iqlocate_cursor((char *) syscurs, 100), (struct sqlda *) 0, (struct sqlda *) 0, sysdesc, &_FS0);
#line 149 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 149 "ix_dbc.esql.ec"
    ix_err();
#line 149 "ix_dbc.esql.ec"
  }

   if (!chkerr())
      _eof=true;
   else
      _eof=strncmp(SQLSTATE, "02", 2) == 0;
};

boolean IxDBC::eof(){
   return _eof;
};

unsigned int IxDBC::getFieldCount(){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 162 "ix_dbc.esql.ec"

#line 163 "ix_dbc.esql.ec"
int sels;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 164 "ix_dbc.esql.ec"


/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 166 "ix_dbc.esql.ec"

#line 167 "ix_dbc.esql.ec"
char *sysdesc;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 168 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;

/*
 *    EXEC SQL get descriptor :sysdesc :sels = COUNT;
 */
#line 171 "ix_dbc.esql.ec"
  {
#line 171 "ix_dbc.esql.ec"
  static struct hostvar_struct _SQhtab[] =
    {
      { 0, 0, 102, sizeof(sels), 0 },
      { 0, 0, 0, 0, 0 }
#line 171 "ix_dbc.esql.ec"
    };
  _SQhtab[0].hostaddr = (char *)&sels;
#line 171 "ix_dbc.esql.ec"
  _iqgetdesc(sysdesc, -1, _SQhtab, 0);
#line 171 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 171 "ix_dbc.esql.ec"
    ix_err();
#line 171 "ix_dbc.esql.ec"
  }

   return (unsigned int) sels;
};

void IxDBC::trim_r(char a[], size_t len){
   for(size_t i = len - 1 - 1; i > 0; i--)
      if (a[i] == ' ')
         a[i] = '\0';
      else
         return;
}

const char *IxDBC::getFieldData(unsigned int no){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 185 "ix_dbc.esql.ec"

#line 186 "ix_dbc.esql.ec"
int no1;
static char data[FIELD_BUFF_SIZE];
int type;
int len;
short ind;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 191 "ix_dbc.esql.ec"


/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 193 "ix_dbc.esql.ec"

#line 194 "ix_dbc.esql.ec"
char *sysdesc;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 195 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;

   /* ESQL hack :) */
   no1=(unsigned int) no + 1;

/*
 *    EXEC SQL get descriptor :sysdesc VALUE	:no1
 * 						:type = TYPE,
 * 						:len = LENGTH,
 * 						:ind = INDICATOR,
 * 						:data = DATA;
 */
#line 201 "ix_dbc.esql.ec"
  {
#line 201 "ix_dbc.esql.ec"
  static struct hostvar_struct _SQhtab[] =
    {
      { 0, 1, 102, sizeof(type), 0 },
      { 0, 2, 102, sizeof(len), 0 },
      { 0, 5, 101, sizeof(ind), 0 },
      { 0, 6, 100, sizeof(data), 0 },
      { 0, 0, 0, 0, 0 }
#line 205 "ix_dbc.esql.ec"
    };
  _SQhtab[0].hostaddr = (char *)&type;
  _SQhtab[1].hostaddr = (char *)&len;
  _SQhtab[2].hostaddr = (char *)&ind;
  _SQhtab[3].hostaddr = (data);
#line 205 "ix_dbc.esql.ec"
  _iqgetdesc(sysdesc, no1, _SQhtab, 0);
#line 205 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 205 "ix_dbc.esql.ec"
    ix_err();
#line 205 "ix_dbc.esql.ec"
  }

   if (ind == -1)
      return NULL;

   trim_r(data, FIELD_BUFF_SIZE);
   return data;
};

const char *IxDBC::getFieldName(unsigned int no){
/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 215 "ix_dbc.esql.ec"

#line 216 "ix_dbc.esql.ec"
int no1;
static char name[FIELDNAME_BUFF_SIZE];
int type;
int len;
short ind;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 221 "ix_dbc.esql.ec"


/*
 *    EXEC SQL BEGIN DECLARE SECTION;
 */
#line 223 "ix_dbc.esql.ec"

#line 224 "ix_dbc.esql.ec"
char *sysdesc;
/*
 *    EXEC SQL END DECLARE SECTION;
 */
#line 225 "ix_dbc.esql.ec"

   sysdesc = IX_DESCR;

   /* ESQL hack :) */
   no1=(unsigned int) no + 1;
   //printf("(((%d)))\n", no);
/*
 *    EXEC SQL get descriptor :sysdesc VALUE	:no1						:name = NAME,
 * 						:name = NAME,
 * 						:type = TYPE,
 * 						:len = LENGTH,
 * 						:ind = INDICATOR;
 */
#line 231 "ix_dbc.esql.ec"
  {
#line 231 "ix_dbc.esql.ec"
  static struct hostvar_struct _SQhtab[] =
    {
      { 0, 7, 100, sizeof(name), 0 },
      { 0, 7, 100, sizeof(name), 0 },
      { 0, 1, 102, sizeof(type), 0 },
      { 0, 2, 102, sizeof(len), 0 },
      { 0, 5, 101, sizeof(ind), 0 },
      { 0, 0, 0, 0, 0 }
#line 235 "ix_dbc.esql.ec"
    };
  _SQhtab[0].hostaddr = (name);
  _SQhtab[1].hostaddr = (name);
  _SQhtab[2].hostaddr = (char *)&type;
  _SQhtab[3].hostaddr = (char *)&len;
  _SQhtab[4].hostaddr = (char *)&ind;
#line 235 "ix_dbc.esql.ec"
  _iqgetdesc(sysdesc, no1, _SQhtab, 0);
#line 235 "ix_dbc.esql.ec"
  if (SQLCODE < 0)
#line 235 "ix_dbc.esql.ec"
    ix_err();
#line 235 "ix_dbc.esql.ec"
  }

   trim_r(name, FIELDNAME_BUFF_SIZE);

   //printf(">%2i | %-10s | %3d | %3d | %3d | %s<\n", no, name, type, len, ind, (ind == -1) ? NULL : data);
   return name;
};

#line 241 "ix_dbc.esql.ec"
